//<!---------------------------------------->
//<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
//<!-- DESC       : ctrl des recettes     -->
//<!-- VERSION    : 1.0                   -->
//<!-- VERS. DATE : 25.02.2022            -->
//<!-- CREA. DATE : 25.02.2022            -->
//<!---------------------------------------->

$(document).ready(function () {
    //creation classe contrôle
    ctrl = new Ctrl();

    //charger script demande
    $.getScript("javascript/service/serviceHTTP.js", function() {
        console.log("serviceHTTP.js charge !");
        ctrl.getRecettes(chargerRecettesSuccess, chargerRecettesError);
        //verifier si le user est connecte
        ctrl.getUser(getInfoUserSuccess, getInfoUserError);
        //si oui, modifier la barre du dessus
    });

});

/**
 * classe contenant les méthodes appelées depuis la page ou depuis d'autres fonctions
 */
class Ctrl {
        
    /**
     * constructeur de la classe 
     */
    constructor() {

    }

    /**
     * Méthode pour récupérer les recettes de la DB
     */
    getRecettes(successCallBack, errorCallBack) {
        //aller chercher les recettes dans la DB
        getRequest(null, successCallBack, errorCallBack, 'recipeManager.php');
    }

    /**
     * méthode pour vérifier si l'utilisateur est connecté et agir en conséquence
     */
    getUser(successCallBack, errorCallBack) {
        getRequest(null, successCallBack, errorCallBack, 'userManager.php');
    }

    /**
     * méthode pour se déconnecter et enlever l'utilisateur de la session
     */
    deconnexion() {
        //se déconnecter du site
        postRequest('action=deconnexion', deconnectionSuccess, deconnectionError, 'userManager.php');
    }
}

/**
 * méthode qui ajoute les recettes reçues dans la page web
 */
function chargerRecettesSuccess(data, text, jqXHR) {
    console.log(data);
	var recettes = data;
    for (var i = 0; i < Object.keys(recettes).length; i++) {
        //definir les paramètres unique
        var pk_recette = recettes[i]["pk"];
        var nom_recette = recettes[i]["nom"];
        var img_recette = recettes[i]["img"];
        var description = recettes[i]["description"];

        //definir les paramètres multiples (ici les ingredients)
        var ingredients = '<ul class="ingredientlist">';

        //  verifier si il y a plus de 4 ingredients

        var hasMoreThan4 = false;
        var IngredListLength = 0;

        if (Object.keys(recettes[i]["ingredients"]).length > 4) {
            IngredListLength = 3;
            hasMoreThan4 = true;
        } else {
            IngredListLength = recettes[i]["ingredients"].length;
        }

        //ajouter les ingredients dans la variable string
        for (var j = 0; j < IngredListLength; j++) {
            var quantite = recettes[i]["ingredients"][j]['quantity'];
            var nom_ingredient = recettes[i]["ingredients"][j]['ingredient'];
            ingredients += '<li>'
                        +  '<p>'
                        +  quantite +' '+ nom_ingredient
                        +  '</p>'
                        +  '</li>';
        }

        if (hasMoreThan4) {
            ingredients += '<li><p>...</p></li>';
        }
        ingredients += '</ul>';

        //creation du string ayant tout le contenu
        var recette = '<div>'
                    + '<ul class="recipebody">'
                    + '<li>'
                    + '<a href="./Recipe.html?ID='+ pk_recette +'">'
                    + '<img class="recipeimage" alt="'+ nom_recette +'" src="'+ img_recette +'">'
                    + '</a>'
                    + '</li>'
                    + '<li>'
                    + '<a href="./Recipe.html?ID='+ pk_recette +'">'
                    + '<p>'+ nom_recette +'</p>'
                    + '</a>'
                    + '<p class="recipedescription">'+ description +'</p>'
                    + ingredients
                    + '</li>'
                    + '</ul>'
                    + '</div>';
		$('#RECIPES').append(recette);
	}
}

/**
 * méthode agissant en cas d'incapacité à récupérer les recettes de la DB
 */
function chargerRecettesError(request, status, error) {
    //alert("Erreur lors de la lecture des recettes: " + error);
    console.log(error);
    console.log(status);

    //AFFICHER UNE PARTIE ALTERNATIVE AU CAS DE NON RECETTES
    //AFFICHER UNE PARTIE ALTERNATIVE AU CAS DE NON RECETTES
    //AFFICHER UNE PARTIE ALTERNATIVE AU CAS DE NON RECETTES
    //AFFICHER UNE PARTIE ALTERNATIVE AU CAS DE NON RECETTES
    //AFFICHER UNE PARTIE ALTERNATIVE AU CAS DE NON RECETTES
    //AFFICHER UNE PARTIE ALTERNATIVE AU CAS DE NON RECETTES
    //AFFICHER UNE PARTIE ALTERNATIVE AU CAS DE NON RECETTES
}

/**
 * méthode agissant lorsqu'un utilisateur est trouvé dans la session
 */
function getInfoUserSuccess(data, text, jqXHR) {
    //afficher la partie user de la barre de navigation
    console.log(data);
    console.log('it worked');
    var contenu =
'<ul>'+
'   <li id="NAV_LOGO_BOX">'+
'       <a href="./" id="NAV_LOGO_LINK">ReciΠ</a>'+
'   </li>'+
'   <li id="NAV_USER_IMAGE_BOX">'+
'       <img id="NAV_USER_IMAGE_IMG" alt="⬤" src="' + data['avatarpath'] + '">'+
'   </li>'+
'   <li id="NAV_USER_NAME_BOX">'+
'       <a id="NAV_USERNAME_TEXT">' + data['name'] + '</a>'+
'   </li>'+
'   <li id="NAV_DELOG_BOX">'+
'       <a id="NAV_DELOG_LINK" onclick="ctrl.deconnexion();">   ❌</a>'+
'   </li>'+
'   <li class="NAV_PAGELINK_BOX">'+
'       <a class="NAV_PAGELINK_LINK" href="./MyUser.html">MyUser</a>'+
'   </li>'+
'   <li class="NAV_PAGELINK_BOX">'+
'       <a class="NAV_PAGELINK_LINK" href="./Recettes.html">Recettes</a>'+
'   </li>'+
'</ul>';

    $('#NAV').html(contenu);
}

/**
 * méthode agissant lorsqu'il n'y a pas d'utilisateur dans la session ou qu'il n'est pas possible de vérifier qu'il y en a un
 */
function getInfoUserError(request, status, error) {
    console.log(status);
    console.log(error);
    console.log('it FAILED');

    var contenu = 
'<ul>'+
'    <li id="NAV_LOGO_BOX">'+
'       <a href="./" id="NAV_LOGO_LINK">ReciΠ</a>'+
'    </li>'+
'    <li id="NAV_CONNEXION_BOX"><a id="NAV_CONNEXION_LINK" href="./Connexion.html">Connexion</a></li>'+
'    <li class="NAV_PAGELINK_BOX">'+
'       <a class="NAV_PAGELINK_LINK" href="./Recettes.html">Recettes</a>'+
'    </li>'+
'</ul>';

    $('#NAV').html(contenu);
}

/**
 * méthode agissant lorsque la déconnexion de l'utilisateur a agis en succès
 */
function deconnectionSuccess(data, text, jqXHR) {
    //afficher la partie user de la barre de navigation
    console.log(data);
    console.log('it worked');
    window.location.href = "./Recettes.html";
}

/**
 * méthode agissant lorsqu'il y a eut une erreur lors de la déconnexion
 */
function deconnectionError(request, status, error) {
    console.log(status);
    console.log(error);
    console.log('it FAILED');
    alert("UNE ERREUR CATASTROPHIQUE S'EST PASSEE");
    window.location.href = "./Recettes.html";
}