//<!---------------------------------------->
//<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
//<!-- DESC       : ctrl des autres users -->
//<!-- VERSION    : 1.0                   -->
//<!-- VERS. DATE : 13.05.2022            -->
//<!-- CREA. DATE : 10.03.2022            -->
//<!---------------------------------------->

$(document).ready(function () {
    //creation classe contrôle
    ctrl = new Ctrl();

    //charger script demande
    $.getScript("javascript/service/serviceHTTP.js", function() {
        console.log("serviceHTTP.js charge !");
        ctrl.getInfos('pk_user='+ new URLSearchParams(window.location.search).get('ID'),chargerRecettesSuccess, chargerRecettesError, chargerUserSuccess, chargerUserError);
        ctrl.getUser(getInfoUserSuccess, getInfoUserError);
    });

    

});

/**
 * classe contenant les méthodes appelées depuis la page ou depuis d'autres fonctions
 */
class Ctrl {
        
    /**
     * constructeur de la classe 
     */
    constructor() {

    }

    /**
     * méthode permettant de récupérer les recettes de l'utilisateur et ses autres informations (dans cet ordre)
     */
    getInfos(pk_user, successCallBack1, errorCallBack1, successCallBack2, errorCallBack2) {
        //aller chercher les recettes dans la DB
        getRequest(pk_user, successCallBack1, errorCallBack1, 'recipeManager.php');
        getRequest(pk_user, successCallBack2, errorCallBack2, 'userManager.php');
    }

    /**
     * méthode permettant de récupérer les informations de l'utilisateur CONNECTÉ
     */
    getUser(successCallBack, errorCallBack) {
        getRequest(null, successCallBack, errorCallBack, 'userManager.php');
    }

    /**
     * méthode permettant à l'utilisateur CONNETCÉ de se déconnecté et de le ramener à la page d'accueil
     */
    deconnexion() {
        //se déconnecter du site
        postRequest('action=deconnexion', deconnectionSuccess, deconnectionError, 'userManager.php');
    }
}

/**
 * méthode agissant lorsque les recettes de l'utilisateur ont pu être récupérée
 */
function chargerRecettesSuccess(data, text, jqXHR) {
    console.log(data);
    var txt = '';
	var recettes = data;
    for (var i = 0; i < Object.keys(recettes).length; i++) {
        //definir les paramètres unique
        var pk_recette = recettes[i]["pk"];
        var nom_recette = recettes[i]["nom"];
        var img_recette = recettes[i]["img"];
        var description = recettes[i]["description"];

        //definir les paramètres multiples (ici les ingredients)
        var ingredients = '<ul class="ingredientlist">';

        //  verifier si il y a plus de 4 ingredients

        var hasMoreThan4 = false;
        var IngredListLength = 0;

        if (Object.keys(recettes[i]["ingredients"]).length > 4) {
            IngredListLength = 3;
            hasMoreThan4 = true;
        } else {
            IngredListLength = recettes[i]["ingredients"].length;
        }

        //ajouter les ingredients dans la variable string
        for (var j = 0; j < IngredListLength; j++) {
            var quantite = recettes[i]["ingredients"][j]['quantity'];
            var nom_ingredient = recettes[i]["ingredients"][j]['ingredient'];
            ingredients += '<li>'
                        +  '<p>'
                        +  quantite +' '+ nom_ingredient
                        +  '</p>'
                        +  '</li>';
        }

        if (hasMoreThan4) {
            ingredients += '<li><p>...</p></li>';
        }
        ingredients += '</ul>';

        //creation du string ayant tout le contenu
        var recette = '<div>'
                    + '<ul class="recipebody">'
                    + '<li>'
                    + '<a href="./Recipe.html?ID='+ pk_recette +'">'
                    + '<img class="recipeimage" alt="'+ nom_recette +'" src="'+ img_recette +'">'
                    + '</a>'
                    + '</li>'
                    + '<li>'
                    + '<a href="./Recipe.html?ID='+ pk_recette +'">'
                    + '<p>'+ nom_recette +'</p>'
                    + '</a>'
                    + '<p class="recipedescription">'+ description +'</p>'
                    + ingredients
                    + '</li>'
                    + '</ul>'
                    + '</div>';

		$('#RECIPES').append(recette);
	}

}

/**
 * méthode agissant lorsque les recettes de l'utilisateur n'ont pas pu être récupérée
 */
function chargerRecettesError(request, status, error) {
    //alert("Erreur lors de la lecture des recettes: " + error);
    console.log(error);
    console.log(status);
}

/**
 * méthode agissant lorsque les informations de l'utilisateur dont la page user est visitée ont pu être récupérée
 */
function chargerUserSuccess(data, text, jqXHR) {
    console.log(data);
    var username = data['name'];
    var description = data['description'];
    var image = data['avatarpath'];
    var contenu = '<table class="OTHERUSER_PRESENTATION_BOX">'
                + '<tr>'
                + '<td>'
                + '<img alt="⬤" src="' + image + '">'
                + '</td>'
                + '<td>'
                + '<h1>' + username + '</h1>'
                + '<p>' + description + '</p>'
                + '</td>'
                + '</tr>'
                + '</table>';
    $('#OTHERUSER').html(contenu);
}

/**
 * méthode agissant lorsque les informations de l'utilisateur dont la page user est visitée n'ont pas pu être récupérée
 */
function chargerUserError(request, status, error) {
    //alert("Erreur lors de la lecture des recettes: " + error);
    console.log(error);
    console.log(status);
}

/**
 * méthode agissant lorsqu'un utilisateur a été trouvé dans la session
 */
function getInfoUserSuccess(data, text, jqXHR) {
    //afficher la partie user de la barre de navigation
    console.log(data);
    console.log('it worked');
    var contenu =
'<ul>'+
'   <li id="NAV_LOGO_BOX">'+
'       <a href="./" id="NAV_LOGO_LINK">ReciΠ</a>'+
'   </li>'+
'   <li id="NAV_USER_IMAGE_BOX">'+
'       <img id="NAV_USER_IMAGE_IMG" alt="⬤" src="' + data['avatarpath'] + '">'+
'   </li>'+
'   <li id="NAV_USER_NAME_BOX">'+
'       <a id="NAV_USERNAME_TEXT">' + data['name'] + '</a>'+
'   </li>'+
'   <li id="NAV_DELOG_BOX">'+
'       <a id="NAV_DELOG_LINK" onclick="ctrl.deconnexion();">   ❌</a>'+
'   </li>'+
'   <li class="NAV_PAGELINK_BOX">'+
'       <a class="NAV_PAGELINK_LINK" href="./MyUser.html">MyUser</a>'+
'   </li>'+
'   <li class="NAV_PAGELINK_BOX">'+
'       <a class="NAV_PAGELINK_LINK" href="./Recettes.html">Recettes</a>'+
'   </li>'+
'</ul>';

    $('#NAV').html(contenu);
}

/**
 * méthode agissant lorsqu'un utilisateur n'a pas été trouvé dans la session ou que l'on ne peut vérifier cela
 */
function getInfoUserError(request, status, error) {
    console.log(status);
    console.log(error);
    console.log('it FAILED');

    var contenu = 
'<ul>'+
'    <li id="NAV_LOGO_BOX">'+
'       <a href="./" id="NAV_LOGO_LINK">ReciΠ</a>'+
'    </li>'+
'    <li id="NAV_CONNEXION_BOX"><a id="NAV_CONNEXION_LINK" href="./Connexion.html">Connexion</a></li>'+
'    <li class="NAV_PAGELINK_BOX">'+
'       <a class="NAV_PAGELINK_LINK" href="./Recettes.html">Recettes</a>'+
'    </li>'+
'</ul>';

    $('#NAV').html(contenu);
}

/**
 * méthode agissant lorsque la déconnexion s'est bien passée
 */
function deconnectionSuccess(data, text, jqXHR) {
    //afficher la partie user de la barre de navigation
    console.log(data);
    console.log('it worked');
    window.location.href = "./Recettes.html";
}

/**
 * méthode agissant lorsque la déconnexion a rencontrée une erreur
 */
function deconnectionError(request, status, error) {
    console.log(status);
    console.log(error);
    console.log('it FAILED');
    alert("UNE ERREUR CATASTROPHIQUE S'EST PASSEE");
    window.location.href = "./Recettes.html";
}