<?php 
/*
<!---------------------------------------->
<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
<!-- DESC       : beans des ingrédients -->
<!-- VERSION    : 1.1                   -->
<!-- VERS. DATE : 13.05.2022            -->
<!-- CREA. DATE : 25.02.2022            -->
<!---------------------------------------->*/

/**
 * classe contenant les informations d'un ingrédient
 */
class Ingredient implements JsonSerializable {

    private $pk_ingredient;
    private $quantity;
    private $name;

    /**
     * méthode permettant de contruire l'objet (constructor)
     */
    public function __construct($pk_ingredient, $name, $quantity) {
        $this->pk_ingredient = $pk_ingredient;
        $this->quantity = $quantity;
        $this->name = $name;
    }

    /**
     * permet de récupérer la quantité de l'ingrédient
     */
    public function getQuantity() {
        return $this->quantity; 
    }

    /**
     * permet de récupérer la primary key de l'ingrédient
     */
    public function getPK_Ingredient() {
        return $this->pk_ingredient; 
    }

    /**
     * permet de récupérer le nom de l'ingrédient
     */
    public function getName() {
        return $this->name; 
    }



    //aucun setter n'est utilisé dans le code pour les ingrédients


    /**
     * permet de retourner rapidement un JSON de l'ingrédient
     */
    public function jsonSerialize()
{
    return 
        [
            'pk'   => $this->getPK_Ingredient(),
            'quantity' => $this->getQuantity(),
            'ingredient' => $this->getName()
        ];
}
}



?>