<?php
/*<!---------------------------------------->
<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
<!-- DESC       : beans des recettes    -->
<!-- VERSION    : 1.1                   -->
<!-- VERS. DATE : 13.05.2022            -->
<!-- CREA. DATE : 25.02.2022            -->
<!---------------------------------------->*/ 

/**
 * classe contenant les informations d'une recette
 */
class Recipe implements JsonSerializable {

    private $pk_recipe;
    private $name;
    private $description;
    private $image;
    private $fk_user;
    private $ingredients;
    private $steps;

    /**
     * méthode permettant de contruire l'objet (constructor)
     */
    public function __construct($pk_recipe, $name, $image, $description, $fk_user, $steps, $ingredients) {
        $this->pk_recipe = $pk_recipe;
        $this->name = $name;
        $this->description = $description;
        $this->image = $image;
        $this->fk_user = $fk_user;
        $this->ingredients = $ingredients;
        $this->steps = $steps;
    }

    /**
     * permet de récupérer le nom de la recette
     */
    public function getName() {
        return $this->name; 
    }

    /**
     * permet de récupérer la primary key de la recette
     */
    public function getPK_Recipe() {
        return $this->pk_recipe; 
    }

    /**
     * permet de récupérer la description de la recette
     */
    public function getDescription() {
        return $this->description; 
    }

    /**
     * permet de récupérer l'image de la recette
     */
    public function getImage() {
        return $this->image; 
    }

    /**
     * permet de récupérer la foreign key désignant la PK du propriétaire de la recette
     */
    public function getFK_User() {
        return $this->fk_user; 
    }

    /**
     * permet de récupérer les ingrédients de la recette
     */
    public function getIngredients() {
        return $this->ingredients; 
    }

    /**
     * permet de récupérer les étapes de la recette
     */
    public function getSteps() {
        return $this->steps; 
    }


    /**
     * permet de définir les ingrédients de la recette
     */
    public function setIngredients($ingredients) {
        $this->ingredients = $ingredients; 
    }
    
    //aucun setter n'est utilisé dans le code pour les recettes hors pour changer les ingrédients

    /**
     * permet de retourner rapidement un JSON de la recette
     */
    public function jsonSerialize()
    {
        return 
            [
                'pk'   => $this->getPK_Recipe(),
                'nom' => $this->getName(),
                'img' => $this->getImage(),
                'fk_user' => $this->getFK_User(),
                'description' => $this->getDescription(),
                'ingredients' => $this->getIngredients(),
                'steps' => $this->getSteps()
            ];
    }
}



?>