<?php 
/*
<!---------------------------------------->
<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
<!-- DESC       : beans des étapes      -->
<!-- VERSION    : 1.1                   -->
<!-- VERS. DATE : 13.05.2022            -->
<!-- CREA. DATE : 18.02.2022            -->
<!---------------------------------------->
 */
 
 /**
 * classe contenant les informations d'une étape
 */
class Step implements JsonSerializable {

    private $pk_step;
    private $fk_recipe;
    private $description;
    private $priority;

    /**
     * méthode permettant de contruire l'objet (constructor)
     */
    public function __construct($pk_step, $priority, $description, $fk_recipe) {
        $this->pk_step = $pk_step;
        $this->fk_recipe = $fk_recipe;
        $this->description = $description;
        $this->priority = $priority;
    }

    /**
     * permet de récupérer la foreign key désignant la PK de la recette de l'étape
     */
    public function getFK_Recipe() {
        return $this->fk_recipe; 
    }

    /**
     * permet de récupérer la primary key de l'étape
     */
    public function getPK_Step() {
        return $this->pk_step; 
    }

    /**
     * permet de récupérer la description de l'étape
     */
    public function getDescription() {
        return $this->description; 
    }

    /**
     * permet de récupérer le niveau de priorité de l'étape
     */
    public function getPriority() {
        return $this->priority; 
    }


    //aucun setter n'est utilisé dans le code pour les étapes

    /**
     * permet de retourner rapidement un JSON de l'étape
     */
public function jsonSerialize()
{
    return 
        [
            'pk'   => $this->getPK_Step(),
            'priority' => $this->getPriority(),
            'fk_recipe' => $this->getFK_Recipe(),
            'description' => $this->getDescription()
        ];
}
}



?>