<?php 
/*
<!---------------------------------------->
<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
<!-- DESC       : beans des users       -->
<!-- VERSION    : 1.1                   -->
<!-- VERS. DATE : 13.05.2022            -->
<!-- CREA. DATE : 18.02.2022            -->
<!---------------------------------------->
 */
 
/**
 * classe contenant les informations d'un utilisateur
 */
class User implements JsonSerializable {

    private $pk_user;
    private $name;
    private $description;
    private $email;
    private $password;
    private $avatarpath;

    /**
     * méthode permettant de contruire l'objet (constructor)
     */
    public function __construct($pk_user, $email, $description, $name, $password, $avatarpath) {
        $this->pk_user = $pk_user;
        $this->name = $name;
        $this->description = $description;
        $this->email = $email;
        $this->password = $password;
        $this->avatarpath = $avatarpath;
    }

    /**
     * permet de récupérer le nom du user
     */
    public function getName() {
        return $this->name; 
    }

    /**
     * permet de récupérer la primary key du user
     */
    public function getPK_User() {
        return $this->pk_user; 
    }

    /**
     * permet de récupérer la description du user
     */
    public function getDescription() {
        return $this->description; 
    }

    /**
     * permet de récupérer l'email du user
     */
    public function getEmail() {
        return $this->email; 
    }

    /**
     * permet de récupérer le mot de passe du user (méthode jamais utilisée)
     */
    public function getPassword() {
        return $this->password; 
    }

    /**
     * permet de récupérer la photo de profil du user
     */
    public function getAvatarPath() {
        return $this->avatarpath; 
    }


    //aucun setter n'est utilisé dans le code pour le USER

    /**
     * permet de retourner rapidement un JSON du user
     */
    public function jsonSerialize() {
        return 
            [
                'pk'   => $this->getPK_User(),
                'name' => $this->getName(),
                'email' => $this->getEmail(),
                'description' => $this->getDescription(),
                'password' => $this->getPassword(),
                'avatarpath' => $this->getAvatarPath()
            ];
    }
}



?>