<?php 
/*
<!---------------------------------------->
<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
<!-- DESC       : manager des sessions  -->
<!-- VERSION    : 1.2                   -->
<!-- VERS. DATE : 13.05.2022            -->
<!-- CREA. DATE : 10.03.2022            -->
<!---------------------------------------->
*/

/**
 * classe servnat à récupérer et modifier les informations stockées dans la session
 */
class SessionManager {

    /**
     * construit une instance du manager
     */
    public function __construct() {
        session_start();
    }

    /**
     * détruit la session actuelle du user
     */
    public function destroySession() {
        return session_destroy();
    }

    /**
     * ouvre la session pour un user
     */
    public function openSession($pk_user) {
        $_SESSION['logged'] = $pk_user;
    }

    /**
     * vérifie que la session contient un user
     */
    public function isConnected() {
        return isset($_SESSION['logged']);
    }

    /**
     * retourne la pk du user stocké
     */
    public function getCurrentUser() {
        return $_SESSION['logged'];
    }
}

?>