<?php 
/*
<!---------------------------------------->
<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
<!-- DESC       : manager des recettes  -->
<!-- VERSION    : 1.2                   -->
<!-- VERS. DATE : 10.03.2022            -->
<!-- CREA. DATE : 18.02.2022            -->
<!---------------------------------------->
*/
	include_once('../wrk/RecipeDBManager.php');
    include_once('./SessionManager.php');
    
    if (isset($_SERVER['REQUEST_METHOD']))
	{
	    //Vérifie la méthode utilisée pour accéder à la DB
		switch ($_SERVER['REQUEST_METHOD'])
		{

            case 'DELETE': //supprime une recette si la recette indiquée par la PK est possédée par le user dans la session
                parse_str(file_get_content("php://input", $vars));
                $sessionCtrl = new SessionManager();
                $wrkDB = new recipeDBManager();
                
                $pk = $vars['pk'];
                $fk_user = $sessionCtrl->getCurrentUser();
                
                if($pk == null || $fk_user == null) {
                    http_response_code(403);
                    echo json_encode(array('message' => 'NOT YOUR RECIPE'));
                } else {
                    
                    $result = $wrkDB->deleteRecipe($pk, $fk_user);
                    
                    if($result == 'does not exist') {
                        http_response_code(400);
                        echo json_encode(array('message' => 'Recipe not found, or not yours.'));
                    } else if ($result == true) {
                        http_response_code(200);
                        echo json_encode(array('message' => 'OK'));
                    } else {
                        http_response_code(500);
                        echo json_encode(array('message' => 'BIG UNKNOWN ERROR'));
                    }
                }

            break;


			case 'GET':
			    
                if( isset($_GET['pk_user']) ) {//récupère les recettes d'un autre user
                    

                    $wrkDB = new recipeDBManager();

                    $result = $wrkDB->getRecipeOfUser($_GET['pk_user']);

                    if($result == 'invalid ID') {
                        http_response_code(400);
                        echo json_encode(array('message' => 'INVALID ID'));
                    } else if ($result != false) {
                        http_response_code(200);
                        echo $result;
                    } else {
                        http_response_code(500);
                        echo json_encode(array('message' => 'ERROR'));
                    }

                } else if ( isset($_GET['pk_recipe']) ) {//obtiens les informations d'une recette unique
                    $wrkDB = new recipeDBManager();
                    
                    $result = $wrkDB->getRecipe($_GET['pk_recipe']);
                    
                    if($result == 'invalid ID') {
                        http_response_code(400);
                        echo json_encode(array('message' => 'INVALID ID'));
                    } else if ($result != false) {
                        http_response_code(200);
                        echo $result;
                    } else {
                        http_response_code(500);
                        echo json_encode(array('message' => 'ERROR'));
                    }
                    
                } else if (isset($_GET['myself'])) {//récupère les informations de l'utilisateur dans la session
                    
                    $sessionCtrl = new SessionManager();
                    if ($sessionCtrl->isConnected()) {
                        
                        $wrkDB = new recipeDBManager();

                        $fk_user = $sessionCtrl->getCurrentUser();
                        $result = $wrkDB->getRecipeOfMyUser($fk_user);

                        if($result == 'invalid ID') {
                            http_response_code(400);
                            echo json_encode(array('message' => 'INVALID ID'));
                        } else if ($result != false) {
                            http_response_code(200);
                            echo $result;
                        } else {
                            http_response_code(500);
                            echo json_encode(array('message' => 'ERROR'));
                        }
                    } else {
                        http_response_code(403);
                        echo json_encode(array('message' => 'NOT LOGGED'));
                    }
                } else { //récupère toutes les recettes
                    $wrkDB = new recipeDBManager();

                    $result = $wrkDB->getAllRecipes();

                    if ($result != false) {
                        http_response_code(200);
                        echo $result;
                    } else {
                        http_response_code(500);
                        echo json_encode(array('message' => 'ERROR'));
                    }
                    
                }
			break;

            case 'POST':
                if( isset($_POST['name']) && isset($_POST['description']) && isset($_POST['image'])) { //ajoute une recette dans la DB
                    //vérifier que la session est ouverte et correcte
                    $sessionCtrl = new SessionManager();
                    if ($sessionCtrl->isConnected()) {
                        //récupérer la pk du user
                        $fk_user = $sessionCtrl->getCurrentUser();
                        //lancer vers le worker
                        $wrkDB = new recipeDBManager();
                        $result = $wrkDB->addRecipe($fk_user, $_POST['name'], $_POST['description'], $_POST['image']);

                        //vérifier que la réponse est correcte
                        if ($result != false) {
                            http_response_code(200);
                            echo $result;
                        } else {
                            http_response_code(500);
                            echo json_encode(array('message' => 'ERROR'));
                        }

                    } else {
                        http_response_code(403);
                        echo json_encode(array('message' => 'USER IS NOT LOGGED'));
                    }
                } else {
                    http_response_code(400);
                    echo 'MISSING ARGUMENTS';
                }
            break;

            case 'PUT': //modifie une recette
                parse_str(file_get_content("php://input", $vars));

                $sessionCtrl = new SessionManager();
                //STEPS ET INGREDIENTS SERONT DES ARRAY TRANSFORMéS DE JSON, A RECONSTRUIRE. 
                //ce qu'on sait :
                //  pk_recipe
                //  nom
                //  description
                //  image
                //  étapes nouvelles et modifiées
                //  ingrédients nouveaux et modifiés
                //ce que l'on devra chercher :
                //  liens ingrédients-recette et étapes supprimées


                //A. vérifier l'existance et mettre en variable utilisables les informations reçues
                //  A1. les valeurs simples à trouver
                $pk_recipe = $vars['pk_recipe'];
                $nom = $vars['name'];
                $description = $vars['description'];
                $image = $vars['image'];
                $fk_user = $sessionCtrl->getCurrentUser();



                //XXXXX :
                $allSteps = $vars['steps'];
                $allIngredients = $vars['ingredients'];

                if($pk_recipe == null || $nom == null || $description == null || $image == null || $fk_user == null || $allSteps == null || $allIngredients == null ) {
                    //  A2. tous les ingrédients passés (transformation en forme valide)
                    //      A2a. la donnée brute (en String)
                    //XXXXX

                    //      A2b. la données rafinée en JSON.
                    $JSONIngredients = json_decode($allIngredients);

                    //      A2c. séparer le JSON en deux array : ingrédients modifiés et ingrédients nouveaux.
                    $IngredientsToModify = array();
                    $IngredientsToAdd = array();
                    
                    $IngredPKList = array();

                    foreach($JSONIngredients as $data) {
                        $SingleIngredient = new Ingredient($data['pk'], $data['ingredient'], $data['quantity']);
                        //si la pk vaut ADD (indicateur d'une nouvelle donnée)
                        if(strcmp($data['pk'], "ADD") == 0) {
                            $IngredientsToAdd[] = $SingleIngredient;
                        } else {
                            $IngredientsToModify[] = $SingleIngredient;
                            $IngredPKList[] = $data['pk'];
                        }
                    }



                    //  A3. toutes les étapes passées (transformation en forme valide)
                    //      A3a. la donnée brute (en String)
                    //XXXXX

                    //      A3b. la données rafinée en JSON.
                    $JSONSteps = json_decode($allSteps);

                    //      A3c. séparer le JSON en deux array : étapes modifiées et étapes nouvelles.
                    $StepsToModify = array();
                    $StepsToAdd = array();

                    $StepPKList = array();

                    foreach($JSONSteps as $data) {
                        $SingleStep = new Step($data['pk'], $data['priority'], $data['description'], $data['fk_recipe']);
                        //si la pk vaut ADD (indicateur d'une nouvelle donnée)
                        if(strcmp($data['pk'], "ADD") == 0) {
                            $StepsToAdd[] = $SingleStep;
                        } else {
                            $StepsToModify[] = $SingleStep;
                            $StepPKList[] = $data['pk'];
                        }
                    }

                    //B. obtenir de la recette dans la DB
                    $RecipeOfDB = $wrkDB->getRecipe($pk_recipe);

                    if(!strcmp('invalid ID', $RecipeOfDB)) {
                        $IngredientsOfDB = $RecipeOfDB['ingredients'];
                        $StepsOfDB = $RecipeOfDB['steps'];


                        //  B1. en comparant avec les données reçue,
                        //      obtenir la liste des ingrédients à supprimer
                        $IngredPKToDelete = array();

                        foreach($IngredientsOfDB as $data) {
                            if(!in_array($data[''], $IngredPKList, true)) {
                                $IngredPKToDelete[] = $data['pk'];
                            }
                        }

                        //  B2. en comparant avec les données reçue,
                        //      obtenir la liste des étapes à supprimer
                        $StepPKToDelete = array();
                        foreach($StepsOfDB as $data) {
                            if(!in_array($data[''], $StepPKList, true)) {
                                $StepPKToDelete[] = $data['pk'];
                            }
                        }


                        //C. modifications à la DB, on s'arrête si on reçoit une erreur

                        //  C1. mise à jour des paramètres simples
                        $update1Result = $wrkDB->updateRecipe($pk_recipe, $fk_user, $image, $description, $nom);

                        if($update1Result) {

                            //CODE A SECURISER ?????
                            //CODE A SECURISER ?????
                            //CODE A SECURISER ?????
                            //CODE A SECURISER ?????
                            //CODE A SECURISER ?????
                            //CODE A SECURISER ?????
                            //CODE A SECURISER ?????
                            //CODE A SECURISER ?????

                            //  C2. actions sur les ingrédients

                            //    C2a. ajout des nouveaux ingrédients (on met leur PK directement dans l'array, puis on créé la relation)

                            //array pour récolter les réussites/échecs
                            $c2aWasCorrect = array();

                            foreach($IngredientsToAdd as $singleIngredToAdd) {
                                $singleIngredToAdd['pk'] = $wrkDB->addIngredient($singleIngredToAdd['ingredient']);

                                $c2aWasCorrect[] = [
                                    'adding Ingredient with PK' => $singleIngredToAdd['pk'],
                                    'has operation worked' => $wrkDB->addRecipeIngredient($pk_recipe, $singleIngredToAdd['pk'], $singleIngredToAdd['quantity'])
                                ];
                            }

                            

                            //    C2b. modifications des ingrédients existant

                            //array pour récolter les réussites/échecs
                            $c2bWasCorrect = array();
                            
                            foreach($IngredientsToModify as $singleIngredToModify) {
                                //vérifier si l'ingrédient a le même nom dans la relation
                                $IngredInDB = $wrkDB->getElement($singleIngredToModify['ingredient']);

                                if($IngredInDB == false) {
                                    //si non, faire les étapes suivantes (X) :
                                    //X1. créer un nouvel ingrédient et récupérer sa PK
                                    $pkNewIngred = $wrkDB->addIngredient($singleIngredToModify['ingredient']);
                                    
                                    //X2. supprimer la relation déjà existante
                                    $deletionResult = $wrkDB->deleteRecipeIngredientLink($pk_recipe, $singleIngredToModify['pk']);

                                    //X3. créer une nouvelle relation avec les données reçues
                                    $newIngredRelation = $wrkDB->addRecipeIngredient($pk_recipe, $pkNewIngred, $singleIngredToModify['quantity']);

                                    $c2bWasCorrect[] = [
                                        'changing name (and quantity) to Ingred' => $singleIngredToModify,
                                        'new PK' => $pkNewIngred,
                                        'has deletion worked' => $deletionResult,
                                        'has new relation addition worked' => $newIngredRelation
                                    ];

                                } else {
                                    //si oui, faire les étapes suivantes (Y) :
                                    //Y1. modifier la relation existante
                                    $c2bWasCorrect[] = [
                                        'modifying quantity of ingred' => $IngredInDB,
                                        'has worked' => $wrkDB->updateRecipeIngredientLink($pk_recipe, $singleIngredToModify['pk'], $singleIngredToModify['quantity'])
                                    ];
                                }
                            }


                            //    C2c. supprimer la relation des ingrédients restants

                            //array pour récolter les réussites/échecs
                            $c2cWasCorrect = array();

                            foreach($IngredPKToDelete as $singleIngredPKToDelete) {
                                $c2cWasCorrect[] = [
                                    'deleting IngredientLink with IngredPK' => $singleIngredPKToDelete,
                                    'has operation worked' => $wrkDB->deleteRecipeIngredientLink($pk_recipe, $singleIngredPKToDelete)
                                ];
                            }




                            //  C3. actions sur les étapes

                            //    C3a. ajout des nouvelles étapes

                            //array pour récolter les réussites/échecs
                            $c3aWasCorrect = array();

                            foreach($StepsToAdd as $singleStepToAdd) {
                                $c3aWasCorrect[] = [
                                    'adding step' => $singleStepToAdd,
                                    'step PK is' => $wrkDB->addStep($pk_recipe, $singleStepToAdd['description'], $singleStepToAdd['priority'])
                                ];
                            }
                                


                            //    C2b. modifications des étapes existantes

                            //array pour récolter les réussites/échecs
                            $c3bWasCorrect = array();

                            foreach($StepsToModify as $singleStepToModify) {
                                $c3bWasCorrect[] = [
                                    'modifying step' => $singleStepToModify,
                                    'step PK is' => $wrkDB->updateStep($singleStepToModify['pk'], $singleStepToModify['priority'], $singleStepToModify['description'])
                                ];
                            }



                            //    C2c. supprimer les étapes restantes

                            //array pour récolter les réussites/échecs
                            $c3cWasCorrect = array();
                            
                            foreach($StepPKToDelete as $singleStepPKToDelete) {
                                $c3cWasCorrect[] = [
                                    'deleting Step with PK' => $singleStepPKToDelete,
                                    'has operation worked' => $wrkDB->deleteStep($singleStepPKToDelete)
                                ];
                            }

                            
                            //combiner les logs et les renvoyer
                            $recipeModLogs = [
                                'adding ingredient results :' => $c2aWasCorrect,
                                'modifying ingredient results :' => $c2bWasCorrect,
                                'deleting ingredient results :' => $c2cWasCorrect,
                                'adding step results :' => $c3aWasCorrect,
                                'modifying step results :' => $c3bWasCorrect,
                                'deleting step results :' => $c3cWasCorrect
                            ];

                            echo $recipeModLogs;

                        } else {
                            http_response_code(500);
                            echo 'recipe not found';
                        }
                    } else {
                        http_response_code(400);
                        echo 'recipe does not exist';
                    }
                } else {
                    //si il manque des variables :
                    http_response_code(400);
                    echo 'not enought parameters passed';
                }
            break;
		}
	}

?>