
<?php 
/*
    <!---------------------------------------->
    <!-- AUTHOR     : DIAS MADEIRA LUCA     -->
    <!-- DESC       : manager des users    -->
    <!-- VERSION    : 1.2                   -->
    <!-- VERS. DATE : 13.05.2022            -->
    <!-- CREA. DATE : 18.02.2022            -->
    <!---------------------------------------->
*/
	include_once('../wrk/UserDBManager.php');
    include_once('./SessionManager.php');

    $sessionManager = new SessionManager();

    if (isset($_SERVER['REQUEST_METHOD']))
	{
	    //Vérifie le type de requête utilisé
		switch ($_SERVER['REQUEST_METHOD'])
		{
			case 'GET':
                
                if( isset($_GET['pk_user']) ) {//retourne les informations publique d'un autre user

                    $wrkDB = new userDBManager();

                    $result = $wrkDB->getUser($_GET['pk_user']);

                    if($result == 'invalid ID') {
                        http_response_code(400);
                        echo json_encode(array('message' => 'INVALID ID'));
                    } else if ($result != false) {
                        http_response_code(200);
                        echo $result;
                    } else {
                        http_response_code(500);
                        echo json_encode(array('message' => 'ERROR'));
                    }

                } else if ($sessionManager->isConnected()) {//retourne les infos de son propre user
                    $wrkDB = new userDBManager();

                    $result = $wrkDB->getUser($sessionManager->getCurrentUser());


                    if($result == 'invalid ID') {
                        http_response_code(400);
                        echo json_encode(array('message' => 'INVALID SESSION'));
                    } else if ($result != false) {
                        http_response_code(200);
                        echo $result;
                    } else {
                        http_response_code(500);
                        echo json_encode(array('message' => 'ERROR'));
                    }


                } else {
                    http_response_code(400);
                    echo 'bad request';
                }
			break;

            case 'POST': 
                if(isset($_POST['name']) && isset($_POST['email']) && isset($_POST['password']) ) { //ajoute un nouvel utilisateur

                    $wrkDB = new userDBManager();

                    $result = $wrkDB->addUser($_POST['name'], $_POST['email'], $_POST['password']);


                    
                    if($result == 'email or username already taken') {
                        http_response_code(400);
                        echo json_encode(array('message' => 'email or username already taken'));
                    } else if ($result != false) {
                        $sessionManager->openSession($result);
                        http_response_code(200);
                        //echo '';
                    } else {
                        http_response_code(500);
                        echo json_encode(array('message' => 'ERROR'));
                    }

                } else if(isset($_POST['action']) && $sessionManager->isConnected()) { //enlève l'utilisateur de la session

                    if($sessionManager->destroySession()) {
                        http_response_code(200);
                        //echo '';
                    } else {
                        http_response_code(500);
                        echo json_encode(array('message' => 'tried to destroy a non-existant session'));
                    }


                } else {
                    http_response_code(500);
                    echo 'bad request';
                }
            break;

            case 'PUT': //modifie les paramètres de l'utilisateur
                parse_str(file_get_content("php://input", $vars));
                
                $sessionCtrl = new SessionManager();
                $wrkDB = new userDBManager();
                
                
                //'pk=' + this.pk + '&description=' + description + '&image=' + avatarPath;
                $pk_user_sent = $vars['pk'];
                $pk_user_of_session = $sessionCtrl->getCurrentUser();
                $description = $vars['description'];
                $image = $vars['image'];
                
                
                if($pk_user_sent != $pk_user_of_session) {
                    http_response_code(403);
                    echo json_encode(array('message' => 'NOT YOUR RECIPE'));
                } else {
                    $result = $wrkDB->updateUser($pk_user_sent, $description, $image);
                    
                                        if($result == 'does not exist') {
                        http_response_code(400);
                        echo json_encode(array('message' => 'Recipe not found, or not yours.'));
                    } else if ($result == true) {
                        http_response_code(200);
                        echo json_encode(array('message' => 'OK'));
                    } else {
                        http_response_code(500);
                        echo json_encode(array('message' => 'BIG UNKNOWN ERROR'));
                    }
                }
            break;
		}
	}
?>