<?php
/*
<!---------------------------------------->
<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
<!-- DESC       : manager db des logins -->
<!-- VERSION    : 1.1                   -->
<!-- VERS. DATE : 13.03.2022            -->
<!-- CREA. DATE : 25.02.2022            -->
<!---------------------------------------->
*/ 
	include_once('../wrk/ConnexionDB.php');
    
    /**
     * classe servant à gérer la vérification de logn
     */
	class loginDBManager
	{

        /**
         * vérifie que les informations sont correctes et appartiennent à un utilisateur existant
         */
		public function checkLogin($Username, $Password)
		{
            $answer = 'INCORRECT_LOGIN';
            //0. sécurisation HTTP des paramètres reçu.
            $cname = htmlspecialchars($Username);
            $cpassword = htmlspecialchars($Password);

            //2. récupérer dans la DB le mdp avec le username donné
            $params = array('username' => $cname);
            $query = ConnexionDB::getInstance()->SelectQuery('SELECT user.PK_User pk, user.Password pwd FROM diasmadeiral_151_ldm_db_recipe.t_user user WHERE user.Name = :username', $params);
            
            //3. vérifier si le mdp passé est correct
            if($query) {
                if(!empty($query)) {
                    foreach($query as $data) {
                        if (password_verify($cpassword, $data['pwd'])) {
                            $answer = $data['pk'];
                        }
                    }
                }
            }
            
            return $answer;	
		}
	}
?>